



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>让你的.NET程序支持多语言</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">让你的.NET程序支持多语言</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 00:58:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>辛辛苦苦做出来的软件，我们当然希望能让更多的人用，支持多语言是必须的。下面我将以Asp.net Web Form为例来介绍如何支持多语言。其他程序比如windows程序，过程都是大同小异的。</p>
<h2>大概分以下几个步骤：</h2>
<ol><li>生成默认资源文件，翻译资源文件。</li>
<li>写一点代码实现语言切换</li>
<li>一些高级话题。例子总是简单的，真实项目会遇到哪些问题？</li></ol>
<p>下面是详细步骤：</p>
<h2>生成默认资源文件，翻译资源文件。</h2>
<ol><ol><li>创建一个Asp.net web form 项目，添加一个WebForm, 里面加上一些元素，比如label，button等，设置他们的text。</li>
<li>选择菜单 Tool-&gt;Generate Local Resource, 你会看到VS自动创建了一个文件夹App_LocalResources，并且里面有一个文件WebForm1.aspx.resx。作为一个技术人员，自己打开看一下吧，是个xml文件。<br /><strong>Note</strong>：对于Asp.net MVC我们不能用这样的方式自动生成资源文件，需要自己创建。</li>
<li>3.	这时，打开WebForm1.aspx，你会看到有些东西变了，出现了一些类似meta:resourcekey="Label1Resource1"的代码。这就是理解Asp.net 支持多语言最基础的东西。Asp.net将通过这个resoruceKey来从资源文件中找到对应这个label在不同语言下应该显示的文本。</li>
<li>这个时候，你尝试改变资源文件中的文本呢，然后重新启动调试，你会看到页面上内容会发生变化。好了，到现在已经完成了支持多语言的最基础的东西。</li>
<li>复制这个资源文件WebForm1.aspx.resx，把新文件命名为WebForm1.aspx.zh-CN.resx，把里面的文本改成汉语的。如果你一开始写的就是汉语，那么你可以把它命名为en-US,然后把内容改为英语。</li></ol></ol>
<h2>写一点代码实现语言切换</h2>
<p>6. 如何让页面显示翻译后的内容呢？非常简单，为了测试你可以先这么做：在WebForm1后台代码添加如下方法：</p>
<div>
<pre class="prettyprint linenums">protected override void InitializeCulture()<br />
 {<br />
 Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("zh-CN");<br />
 Thread.CurrentThread.CurrentUICulture = new CultureInfo("zh-CN");<br />
 base.InitializeCulture();<br />
 }
</pre>
</div>
<p>　</p>
<ol><ol><li>添加如上代码后，启动调试你将看到中文页面。尝试把zh-CN改为其他语言代码你的系统将会显示为其他语言。<br />一点小提醒 ：如果对英语言的资源文件不存在，或者某些项不存在，系统将会自动从默认资源文件中查找，所以即使没有翻译完界面上也不会显示空白。</li>
<li>实际项目中你很可能会希望网站可移动台改变语言，这也不复杂，只需要在界面上加上几个链接或者按钮，有时候可以是几个小图片显示不同国家的国旗，当用户点击后把用户的选择保存一下然后再动态替换InitializeCulture()函数中的语言代码即可。</li>
<li>没有多语言经验的程序员在平时编程时会把一些要在界面上显示的内容硬编码到代码中，这样的话在支持多远之前需要把这些硬编码的文本提取到资源文件中。要不然是没法支持多语言的。VS的代码检查工具可以帮你找到这些支持多语言有问题的代码。除了VS自动生成的资源文件，你还可以创建自己的资源文件。</li></ol></ol>
<h2>一些高级话题。</h2>
<p>好吧，实际项目当然没有这么简单，这篇小文章给当然也不可能把实际项目中可能遇到的问题全部讲清楚。我会把我曾经遇到过的比较典型的一些问题以及解决方案写一下。</p>
<ol><ol><li><ol><li><strong>资源的翻译问题。</strong><br />     	实际项目肯定要找专业的翻译人员来翻译，他们怎么打开我们的资源文件呢？比较常用的做法是把资源文件导出到Excel中，或者其他翻译行业专用的格式，翻译完了然后再导入。已经有一些工具支持这个功能。有的项目会有几百个资源文件，这些文件的管理确实并不简单。</li>
<li><strong>翻译的版本管理。</strong><br />     	当我们完成了第一个版本的翻译，有开发出第二个版本时，当然也要对第二个版本进行翻译，因为界面上会有很多新加入的和改变的内容。也许你已经想到将会面临的问题了，该如何找到这些变化了的内容然后把他们发给翻译人员呢？总不能手动比较然后一个一个挑选出来吧！在这里推荐一个我们自己开发的工具，可以帮你找到这些变化了的资源，翻译人员直接登录网站即可完成翻译。网址是 rtp.cleancodesoft.com</li>
<li><strong>界面的布局问题。</strong><br />     	当项目实际翻译完成后，你会发现界面上有些东西乱套了。中文是两个字符的内容英语可能要一长串。对于web程序在写css的时候要考虑这些问题，对于windows程序，则需要重新打开设计器，从属性窗口中选择语言，这时设计器会自动加载选中语言的资源，然后你可以重新调整布局。没有捷径，你需要重新检查所有界面，最好有个细心的tester帮你做这件事。</li>
<li><strong>可不可以不用.resx资源文件？</strong>     	 <br />当然可以。原理都是一样，把需要翻译的内容提取出来，然后动态读取。怎么保存无所谓，方便就好。有很多开源项目和其他平台下的项目都有自己五花八门的办法。但据我所知用.resx应该是最简单的。</li></ol></li></ol></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv16djq.html">List&amp;lt&semi;T&amp;gt&semi;Find方法，FindAll方法，Contains方法，Equals方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxxo7jq.html">Android Studio-目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxxzlvq.html">angularjs 手动加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42j309.html">TMS320C64X&plus; 中使用EDMA3中断</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2wze8.html">&lbrack;codevs2181&rsqb;田忌赛马</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2rj7q.html">java操作word，excel，pdf</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd2n448.html">用extern关键字使程序更加清晰</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpnrwq.html">&period;NET 使用unity实现依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdvr6z9.html">jQuery 核心函数 （十一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k04r59.html">Spring Boot（十四）RabbitMQ延迟队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkj528.html">CSS &colon; color and unit</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjzn69.html">mysql中主键和唯一键的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1mwn9.html">ContentProvider使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyl132q.html">VS Code折腾记 - &lpar;2&rpar; 快捷键大全，没有更全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy75y19.html">&lbrack;LeetCode&rsqb; 830&period; Positions of Large Groups&lowbar;Easy tag&colon; Two Pointers</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1m1pe9.html">洛谷P3862 8月月赛B</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzd2eq.html">SEO如何利用百度知道日引流上千IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/902km7nq.html">洛谷P4245 【模板】MTT&lpar;任意模数NTT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnno5lkq.html">关于asp&period;net MVC3 ----&commat;Html&period;Partial&comma;&commat;Html&period;Action&comma;&commat;Html&period;RenderPartial&comma;&commat;Html&period;RenderAction</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pz23r8.html">404 Note Found 队-课堂实战-项目UML设计</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gmzor49.html">Hibernate从入门到精通（五）一对一单向关联映射</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x3mln9.html">实战开发中UI资源制作标准</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0vwjlq.html">利用JQuery的&dollar;&period;ajax&lpar;&rpar;可以很方便的调用asp&period;net的后台方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e13d6x9.html">vbe6ext&period;olb不能被加载 宏内存溢出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeg6kx9.html">HibernateTemplate、HibernateDaoSupport两种方法实现增删改查Good（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1k3r39.html">SpringJUnit4加载类目录下&lpar;src&rpar;和WEF-INF目录下的配置文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oklndx9.html">Deadline来了，如何按时结题？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zwm309.html">SGU 180</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmpez19.html">oracle-number&lpar;5&comma;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj2p6y9.html">C&num;基础精华02（静态类，值类型，引用类型，枚举，结构，ref与out）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
